//+------------------------------------------------------------------+
//|                                                         StoW.mq4 |
//|                                         Copyright  2010, Geafer |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, Geafer"
#property link      ""

// vlastnosti, kter specifikuj indiktor
#property indicator_separate_window    // uruje, e je indiktor ve vlastnm okn
#property indicator_minimum -100       // definuje nejni hodnoty indiktoru
#property indicator_maximum 100        // definuje nejvy hodnoty indiktoru
#property indicator_buffers 2          // poet buffer dat
#property indicator_color1 Green       // barva indiktoru pro data bufferu 1
#property indicator_color2 Red         // barva indiktoru pro data bufferu 2
#property indicator_level1 75.0        // definuje hranici rovn 1
#property indicator_level2 -75.0       // definuje hranici rovn 2
#property indicator_levelcolor Silver  // barva rovn

// extern promnn, kter me uivatel zmnit v zloce indiktoru Vloit parametry
extern int WPR = 40;    // hodnota %R
extern int K = 18;      // hodnota Stochastic K
extern int D = 6;       // hodnota Stochastic D
extern int Slow = 3;    // hodnota Stochastic Slow

// nae globln promnn, kter tvo buffer dat
double ExtMapBuffer1[];    // data bufferu 1
double ExtMapBuffer2[];    // data bufferu 2

// inicializace
int init()
{
   // nastav styl zobrazen ry pro data bufferu 1
   SetIndexStyle(0,DRAW_HISTOGRAM);
   // piad pole s daty pro buffer 1
   SetIndexBuffer(0,ExtMapBuffer1);
   // nastav styl zobrazen ry pro data bufferu 2
   SetIndexStyle(1,DRAW_HISTOGRAM);
   // piad pole s daty pro buffer 2
   SetIndexBuffer(1,ExtMapBuffer2);
   // Nastav przdnou hodnotu bufferu 1, kter se nebude zobrazovat
   SetIndexEmptyValue(0, 0.0);
   // Nastav przdnou hodnotu bufferu 2, kter se nebude zobrazovat
   SetIndexEmptyValue(1, 0.0);
   return(0);
}

// deinicializace
int deinit()
{
   return(0);
}

// spouten indiktoru
int start()
{
   // zjistme poet vypotanch bar
   int counted_bars=IndicatorCounted();
   // pokud je chyba, tak ukonme
   if(counted_bars < 0) return(-1);
   // pokud jsou ji njak spotan, tak 1 odebereme,
   // protoe chceme ten posledn pepotat,
   // jeliko se v prbhu periody hodnota stle mn
   if(counted_bars > 0) counted_bars--;
   // nastavme si poet bar, kter budeme potat
   int limit = Bars - counted_bars;
 
   // pro kad bar provedeme vpoet
   for(int i = 0; i < limit; i++)
   {
      double value = getValue(i);
      // pokud je hodnota pod nulou,
      // tak zobrazujeme erven, resp. hodnoty bufferu 2
      if(value < 0)
      {
         ExtMapBuffer1[i] = 0;   // nastavme na przdnou hodnotu
         ExtMapBuffer2[i] = value;
      }
      // jinak zobrazujeme zelen, resp. hodnoty bufferu 1
      else
      {
         ExtMapBuffer1[i] = value;
         ExtMapBuffer2[i] = 0;   // nastavme na przdnou hodnotu
      }
   }
   return(0);
}

// vypot hodnotu WPR a Stochastic
double getValue(int shift)
{
   double wpr = getWPR(shift);
   double sto = getSTO(shift, false);
   
   double result = wpr + sto;
   return(result);
}

// vrt hodnotu WPR
double getWPR(int shift)
{
   return(iWPR(Symbol(), Period(), WPR, shift));
}

// vrt hodnotu Stochastic
double getSTO(int shift, bool baseLine)
{
   int mode;
   if(baseLine) mode = MODE_MAIN;
   else mode = MODE_SIGNAL;
   return(iStochastic(Symbol(), Period(), K, D, Slow, MODE_SMA, 0, mode, shift));
}

